// Constants
// ---------
   #define MDI_DESKTOPCLASS             "CanyonMDIDesktop"
   #define MDI_DOCUMENTCLASS            "CanyonMDIDocument"
   #define MDI_MODNAME                  "MDI.DLL"


// Messages
// --------
   #define MDI_MSG_LOCATE_DESKTOP_DATA  WM_USER+1
                                        // mp1 : NULL
                                        // mp2 : NULL

   #define MDI_MSG_LOCATE_DOCUMENT_DATA WM_USER+2
                                        // mp1 : NULL
                                        // mp2 : NULL

   #define MDI_MSG_LOCATE_INSTANCE_DATA WM_USER+3
                                        // mp1 : NULL
                                        // mp2 : NULL


// WM_CONTROL Notification codes
// -----------------------------
   #define MDI_NOTIFY_CREATE_DESKTOP    1
                                        // mp1 : MPFROM2SHORT (idDesktop, MDI_NOTIFY_CREATE_DESKTOP)
                                        // mp2 : PVOID pvDeskData

   #define MDI_NOTIFY_DESTROY_DESKTOP   2
                                        // mp1 : MPFROM2SHORT (idDesktop, MDI_NOTIFY_DESTROY_DESKTOP)
                                        // mp2 : PVOID pvDeskData

   #define MDI_NOTIFY_CREATE_DOCUMENT   3
                                        // mp1 : MPFROM2SHORT (idDesktop, MDI_NOTIFY_CREATE_DOCUMENT)
                                        // mp2 : PVOID pvInstData

   #define MDI_NOTIFY_DESTROY_DOCUMENT  4
                                        // mp1 : MPFROM2SHORT (idDesktop, MDI_NOTIFY_DESTROY_DOCUMENT)
                                        // mp2 : PVOID pvDocData

   #define MDI_NOTIFY_DESTROY_INSTANCE  5
                                        // mp1 : MPFROM2SHORT (idDesktop, MDI_NOTIFY_DESTROY_INSTANCE)
                                        // mp2 : PVOID pvInstData


// Function Declarations
// ---------------------
   HWND    FAR      MDICreateDesktop    (PFNWP, ULONG, PCHAR, HMODULE, USHORT, PHWND, USHORT, USHORT, PCHAR, PCHAR);
                                        // PFNWP   : your desktop window procedure
                                        // ULONG   : FCF_* flags for the desktop frame
                                        // PCHAR   : initial desktop title text
                                        // HMODULE : module handle for resources (or NULL if in .EXE)
                                        // USHORT  : id of resources
                                        // PHWND   : pointer to area in which handle to desktop client is returned
                                        // USHORT  : size of re-entrant desktop data
                                        // USHORT  : id of desktop frame
                                        // PCHAR   : text of menu entry before which the "window" menu entry is inserted
                                        // PCHAR   : desired text of "window" menu entry

   HWND    FAR      MDICreateDocument   (PFNWP, HWND, ULONG, PCHAR, HMODULE, USHORT, PHWND, USHORT, USHORT);
                                        // PFNWP   : your document window procedure
                                        // HWND    : handle to the desktop client window, as returned by MDICreateDesktop
                                        // ULONG   : FCF_* flags for the document frame
                                        // PCHAR   : initial document title
                                        // HMODULE : module handle for resources (or NULL if in .EXE)
                                        // USHORT  : id of resources
                                        // PHWND   : pointer to area in which handle to document client is returned
                                        // USHORT  : size of re-entrant document data
                                        // USHORT  : size of re-entrant document instance data

   MRESULT EXPENTRY MDIDesktopWndProc   (HWND, USHORT, MPARAM, MPARAM);
                                        // HWND    : window handle
                                        // USHORT  : message id
                                        // MPARAM  : mp1
                                        // MPARAM  : mp2

   MRESULT EXPENTRY MDIDocumentWndProc  (HWND, USHORT, MPARAM, MPARAM);
                                        // HWND    : window handle
                                        // USHORT  : message id
                                        // MPARAM  : mp1
                                        // MPARAM  : mp2
